#define  vdev_addr   	0308h
#define  cvdev_addr  	0x0308
#define IDM_ABOUT  	100
#define IDM_ACTION 	101
#define IDM_RESET  	102
#define IDM_READBYTE 	103
#define IDM_KEY		104
#define SHFTMASK 	0x80
#define CTRLMASK 	0x40
#define WM_USER_CHAR    WM_USER + 1

#define LEESCOM         0
#define CTRL_A          1
#define CTRL_B          2
#define CTRL_C          3
#define CTRL_D          4
#define CTRL_E          5
#define CTRL_F          6
#define CTRL_G          7
#define CTRL_H          8
#define CTRL_I          9
#define CTRL_J          10
#define CTRL_K          11
#define CTRL_L          12
#define CTRL_M          13
#define CTRL_N          14
#define CTRL_O          15
#define CTRL_P          16
#define CTRL_Q          17
#define LEESCOM18       18
#define LEESCOM19       19
#define LEESCOM20       20
#define CTRL_U          21
#define CTRL_V          22
#define CTRL_W          23
#define CTRL_X          24
#define LEESCOM25       25
#define CTRL_Z          26
#define LEESCOM27       27
#define CTRL_KM         28
#define CTRL_MN         29
#define HOME            30
#define CTRL_SL         31

#define DRUKAF		0x00
#define KEY		0x01
#define COPY		0x02
#define GPLOT		0x03
#define IGRAPH		0x04
#define SIMULATE4	0x05
#define RAMFNT		0x06
#define SCHRIJF 	0x07
#define SCHAAL		0x08
#define CURSOR_ON	0x09
#define CURSOR_OFF	0x0a
#define LOADFILE	0x0b
#define SAVEFILE	0x0c
#define CAT		0x0d
#define ACHDIR		0x0e
#define ARMDIR		0x0f
#define AMKDIR		0x10
#define DELETE		0x11
#define LOCK		0x12
#define UNLOCK		0x13
#define ADRIVE		0x14
#define MSDOS		0x15
#define HIDE		0x16
#define UNHIDE		0x17
#define INFO		0x18
#define GELUID		0x19
#define BLIEP		0x1a
#define ERRMSG		0x1b
#define KNAAGDIER	0x1c
#define DEFMUISMASKER	0x1d
#define CURSORPOS	0x1e
#define VIDEO		0x1f
#define SERPORT 	0x20
#define PRINTIT 	0x21
#define DOSFUNCTIE	0x22
#define PORT_IN 	0x23
#define PORT_OUT	0x24
#define UDS		0x25
#define MOUSE_MOT	0x26
#define WHOAMI		0x27
#define CLEAR0		0x28
#define PALET		0x29
#define CLEAR1		0x2a
#define CLEAR1A 	0x2b
#define CLEAR2		0x2c
#define CLEAR2A 	0x2d
#define CLEAR3		0x2e
#define CLEAR3A 	0x2f
#define CLEAR4		0x30
#define CLEAR4A 	0x31
#define VIDEOMOD	0x32
#define VIDEOCOL	0x33
#define SCHRIJFPIX	0x34
#define WINDOW		0x35
#define WINDOW_OFF	0x36
#define JOYSTICK	0x37
#define CALLIBRATE	0x38
#define BIT7		0x39
#define BIOSKEY 	0x3a
#define SHELL		0x3b
#define ZOEKFILE	0x3c
#define ZOEKNEXT	0x3d
#define LPT		0x3e
#define RAF_OPEN	0x3f
#define RAF_SLUIT	0x40
#define RAF_SCHRIJF	0x41
#define RAF_LEZEN	0x42
#define RAF_MOVE_PTR	0x43
#define RAF_LEES_EXT	0x44
#define MOUSEKAR	0x45
#define VERSIE		0x46
#define TEKEN2LPT	0x47
#define CGABITMAP	0x48
#define HFILL		0x49
#define VFILL		0x4a
#define ROEP61		0x4b
#define GWINDOW 	0x4c
#define GWOFF		0x4d
#define OORSPRONG	0x4e
#define VIEWSCHERM	0x4f
#define WERKSCHERM	0x50
#define CURSORDEF	0x51
#define READ_B001	0x52
#define READ_B002	0x53
#define WRITE_B000	0x54
#define EGAFONT 	0x55
#define EGA8X14 	0x56
#define EGA8X8		0x57
#define SCHIJFSCRDISK	0x58
#define LEESSCRDISK	0x59
#define GRFUNCTIE	0x5a
#define LEESPCMEM	0x5b
#define WRITPCMEM	0x5c
#define MOVEPCMEM	0x5d
#define WAIT		0x5e
#define PAINT		0x5f

void reset(void);
//void writebyte(unsigned int);
int  readbyte(void);
int  readbytew(void);
void status(void);
void Process(char);

void drukaf(void);
void keyb(void);
int  key(void);
void copy(void);
void gplot(void);
void igraph(void);
void simulate4(void);
void ramfnt(void);
int  schrijf(void);
void schaal(void);
void cursor_on(void);
void cursor_off(void);
int  loadfile(void);
void leesnaam(void);
void pixel(int, int, int);
void error(char);
int  savefile(void);
void cat(void);
void achdir(void);
void armdir(void);
void amkdir(void);
void delete(void);
void alock(void);
void aunlock(void);
void adrive(void);
void msdos(void);
void hide(void);
void unhide(void);
void info(void);
void geluid(void);
void bliep(void);
void errmsg(void);
void knaagdier(void);
void defmuismasker(void);
void cursorpos(void);
void video(void);
void serport(void);
void printit(void);
void dosfunctie(void);
void port_in(void);
void port_out(void);
void uds(void);
void mouse_mot(void);
void whoami(void);
void clear0(void);
void palet(void);
void clear1(void);
void clear1a(void);
void clear2(void);
void clear2a(void);
void clear3(void);
void clear3a(void);
void clear4(void);
void clear4a(void);
void videomod(void);
void videocol(void);
void schrijfpix(void);
void windowd(void);
void window_off(void);
void joystick(void);
void callibrate(void);
void bit7(void);
void bioskey(void);
void shell(void);
void zoekfile(void);
void zoeknext(void);
void lpt(void);
void raf_open(void);
void raf_sluit(void);
void raf_schrijf(void);
void raf_lezen(void);
void raf_move_ptr(void);
void raf_lees_ext(void);
void mousekar(void);
void versie(void);
void teken2lpt(void);
void cgabitmap(void);
void hfill(void);
void vfill(void);
void roep61(void);
void gwindow(void);
void gwoff(void);
void oorsprong(void);
void viewscherm(void);
void werkscherm(void);
void cursordef(void);
void read_b001(unsigned char);
void read_b002(void);
void write_b000(void);
void egafont(void);
void ega8x14(void);
void ega8x8(void);
int  verdubbel(int);